﻿-- Debuff Monitor

function SN:Debuffs()
	
	local f = SN.F
	local m = SN.Media
	--make the frames db local
	local v = SN.db.profile.Frames
	
	f.debuffs = SN:MakeFrame("DBGroup", "debuffs", "SN:arg4", 20)
	f.debuffs:SetScript("OnEvent", function(self, event, unit, ...)
		SN:UpdateDebuff(self, event, unit, ...)
	end)

	--Register our events for the frame
	f.debuffs:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	f.debuffs:RegisterEvent("UNIT_TARGETABLE_CHANGED")
end

function SN:UpdateDebuff(frame, event, unit, ...)

	if event == "UNIT_TARGETABLE_CHANGED" then
		print(...)
	end

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local type, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
		local spellId, spellName, spellSchool = select(11, ...)

		for i, cooldown in pairs(SN.db.profile.debuffs) do
		-- Check to see if the aura is applied and refresh the timer
			if type == cooldown.refresh then
				if spellId == cooldown.id then
					if cooldown.enable then 
						if sourceGUID == UnitGUID("player") then
							tempbar = SN:Find(frame, "SN:arg5", spellName)
							local _, _, _, _, _, dur = UnitDebuff("target", spellName)
							--Is there a bar for this debuff already?
							if tempbar ~= nil then
								tempbar:SetDuration(dur)
								tempbar:Start()
							else
								--Start a new one because there wasn't
								SN:CreateBar(frame, cooldown, dur, sourceName, destGUID, spellName)
							end
						end
					end
				end
			--Start a fresh timer since the aura is not on the target				
			elseif type == cooldown.succ then
				if spellId == cooldown.id then
					if cooldown.enable then
						if sourceGUID == UnitGUID("player") then
							local _, _, _, _, _, dur = UnitDebuff("target", spellName)
							SN:CreateBar(frame, cooldown, dur, sourceName, destGUID, spellName)
						end
					end
				end
			end
		end
		--Serpent Sting refresh with Cobra Shot and Chimera Shot
		if  type == "SPELL_DAMAGE" then
			if spellId == 77767 or spellId == 53209 then
				if sourceGUID == UnitGUID("player") then
					tempbar = SN:Find(frame, "SN:arg5", "Serpent Sting")
					if tempbar ~= nil then
						local _, _, _, _, _, dur, expire = UnitDebuff("target", tempbar:Get("SN:arg5"))
						tempbar:SetDuration(expire)
						tempbar:Start()
					end
				end
			end	
		end
	end
end	